define("Nexus/clm",["Nexus/config","Nexus/messages","Nexus/siesta"],function(){Ext.namespace("Nexus.clm");Nexus.clm.ID="nx-clm";Nexus.clm.TITLE="CLM";Nexus.clm.TITLE_DASHBOARD="CLM Dashboard";Nexus.clm.TAB_TITLE="CLM";Nexus.clm.TAB_ID="clm";Nexus.clm.STAGING_KEY="CLMApplicationID";Nexus.clm.STAGING_LABEL="CLM Application";Nexus.clm.showMessage=function(message){Nexus.messages.show(Nexus.clm.TITLE,message)};Nexus.clm.resourcePath=Nexus.siesta.basePath+"/clm";Nexus.clm.ruleTemplate=NX.create("Ext.XTemplate",'<div class="nx-clm-status {messageClass}">{message}</div>','<div class="nx-staging-repository-ActivityView-messagePanel-head">','<tpl if="violationCount &gt; 0">Violations were found in <b>{violationCount}</b> components.</tpl>','<tpl if="violationCount == 0">No violations found.</tpl>',"</div>",'<div class="nx-clm-alerts">','<tpl if="criticalCount &gt; 0">','<div class="nx-clm-alert_box">','<div class="nx-clm-alert nx-clm-alert_critical">{criticalCount}</div>','<div class="nx-clm-alert_critical_text">CRITICAL</div>',"</div>","</tpl>",'<tpl if="severeCount &gt; 0">','<div class="nx-clm-alert_box">','<div class="nx-clm-alert nx-clm-alert_severe">{severeCount}</div>','<div class="nx-clm-alert_severe_text">SEVERE</div>',"</div>","</tpl>",'<tpl if="moderateCount &gt; 0">','<div class="nx-clm-alert_box">','<div class="nx-clm-alert nx-clm-alert_moderate">{moderateCount}</div>','<div class="nx-clm-alert_moderate_text">MODERATE</div>',"</div>","</tpl>",'<a href="{detailedReport}" target="_blank" class="view-report-button">View Full Report</a>',"</div>",'<br style="clear:both;"/>',{compiled:true});Nexus.clm.chickletTemplate=NX.create("Ext.XTemplate",'<tpl if="criticalCount &gt; 0">','<div class="nx-clm-alert-small nx-clm-alert_critical">{criticalCount}</div>',"</tpl>",'<tpl if="severeCount &gt; 0">','<div class="nx-clm-alert-small nx-clm-alert_severe">{severeCount}</div>',"</tpl>",'<tpl if="moderateCount &gt; 0">','<div class="nx-clm-alert-small nx-clm-alert_moderate">{moderateCount}</div>',"</tpl>",'<tpl if="(criticalCount + severeCount + moderateCount) == 0">No violations</tpl>','<tpl if="detailedReport">','<span class="view-report-link-span">','<a href="{detailedReport}" target="_blank" class="view-report-link">View Full Report</a>',"</span>","</tpl>",{compiled:true});Nexus.clm.stagingRule=function(event,detail){if(detail.getPropertyValue("typeId")==="clm"){var message,messageClass;var status=detail.getPropertyValue("x.appScan.status");if(status===undefined){NX.log.error("Unable to determine status for CLM result:"+detail);return undefined}switch(status){case"PASS":message="Validation was successful!";messageClass="nx-clm-status_success";break;case"WARN":message="There are warnings.";messageClass="nx-clm-status_warn";break;case"FAIL":message="Validation failed.";messageClass="nx-clm-status_fail";break;default:Nexus.clm.showMessage("Unrecognized CLM status: "+details.getPropertyValue("x.appScan.status"))}var violationCount=detail.getPropertyValue("x.appScan.violationCount")||0;var criticalCount=detail.getPropertyValue("x.appScan.threatLevelCount.CRITICAL")||0;var severeCount=detail.getPropertyValue("x.appScan.threatLevelCount.SEVERE")||0;var moderateCount=detail.getPropertyValue("x.appScan.threatLevelCount.MODERATE")||0;return NX.create("Ext.XTemplate","{[ this.render() ]}",{compiled:true,render:function(){return Nexus.clm.ruleTemplate.apply({message:message,messageClass:messageClass,detailedReport:detail.getPropertyValue("x.appScan.url"),violationCount:violationCount,criticalCount:criticalCount,severeCount:severeCount,moderateCount:moderateCount})}})}return undefined}});
NX.define("Nexus.clm.SettingsView",{extend:"Ext.Panel",requires:["Nexus.staging.repository.activity.EventDetail","Nexus.staging.repository.SummaryView","Nexus.staging.repository.RepositoriesMediator"],requirejs:["Nexus/siesta","Nexus/clm"],mixins:["Nexus.LogAwareMixin"],constructor:function(config){var self=this;self.url=new Ext.form.TextField({name:"url",fieldLabel:"CLM Server URL",helpText:"The address of your CLM Server",anchor:Sonatype.view.FIELD_OFFSET,allowBlank:false,itemCls:"required-field",validator:function(v){if(v===""||v.match(/^(?:http|https):\/\//i)){return true}else{return"Protocol must be http:// or https://"}}});self.settingsForm=new Ext.FormPanel({border:false,labelWidth:100,layoutConfig:{labelSeparator:""},items:[self.url,{xtype:"numberfield",name:"timeout",fieldLabel:"Request Timeout",helpText:"Number of seconds Nexus will wait for a successful CLM server connection before retrying. Defaults to 15 minutes.",anchor:Sonatype.view.FIELD_OFFSET,allowBlank:true},{xtype:"textarea",fieldLabel:"Properties",name:"properties",anchor:Sonatype.view.FIELD_OFFSET,helpText:"Additional properties to configure for the CLM Server",flex:1}],buttons:[{text:"Save",tooltip:"Save settings",formBind:true,scope:self,handler:self.saveSettings},{text:"Reset",tooltip:"Reset changes",formBind:true,scope:this,handler:self.loadSettings}]});self.disabledWarning=NX.create("Ext.Panel",{border:false,html:'<div class="nx-clm-disabled-warning"><div>CLM functionality is currently disabled, CLM staging rule execution will be skipped.<br/>To enable it, use Capabilities UI.</div></div>',hidden:true});Ext.apply(self,{cls:"nx-clm-SettingsView",border:false,layout:"vbox",layoutConfig:{align:"stretch"},items:[{xtype:"fieldset",title:"Settings",anchor:Sonatype.view.FIELDSET_OFFSET,autoHeight:true,items:[{border:false,html:'<div class="nx-clm-doco"><a href="http://links.sonatype.com/products/clm/nexus/home"  target="_blank">Make Nexus Staging even more powerful with Sonatype CLM </a></div>'},self.disabledWarning,self.settingsForm]}]});self.constructor.superclass.constructor.apply(self,arguments);self.on("afterlayout",self.loadSettings,self,{single:true})},saveSettings:function(){var self=this,form,url;self.logDebug("CLM Saving settings");form=self.settingsForm.getForm();if(!form.isValid()){return}url=form.findField("url").getValue();Ext.Ajax.request({url:Nexus.clm.resourcePath,method:"POST",scope:self,suppressStatus:400,jsonData:form.getFieldValues(),success:function(){var nexusPanel=Sonatype.repoServer.RepoServer.nexusPanel;Nexus.clm.showMessage("Configuration saved");form.items.each(function(item){item.clearInvalid()});nexusPanel.get("st-enterprise-staging").remove(nexusPanel.clmMenu);Nexus.clm.serverUrl=url;nexusPanel.clmMenu=nexusPanel.add({enabled:true,sectionId:"st-enterprise-staging",title:Nexus.clm.TITLE_DASHBOARD,href:Nexus.clm.serverUrl});nexusPanel.doLayout()},failure:function(response,opts){if(response.siestaValidationError!==undefined){Ext.each(response.siestaValidationError,function(error){form.findField(error.id).markInvalid(error.message)})}}})},loadSettings:function(){var self=this;self.logDebug("CLM Loading settings");Ext.Ajax.request({url:Nexus.clm.resourcePath,method:"GET",scope:self,suppressStatus:404,success:function(response){var config=Ext.decode(response.responseText);self.settingsForm.getForm().setValues(config);if(config.enabled){self.disabledWarning.hide()}else{self.disabledWarning.show()}self.logDebug("CLM Settings loaded")}})}},function(){var type=this;var key=Nexus.clm.STAGING_KEY;var label=Nexus.clm.STAGING_LABEL;Sonatype.Events.addListener("nexusNavigationInit",function(nexusPanel){var p=Sonatype.lib.Permissions;if(p.checkPermission("nexus:settings",p.READ)){nexusPanel.add({enabled:true,sectionId:"st-nexus-config",title:Nexus.clm.TITLE,tabId:Nexus.clm.TAB_ID,tabTitle:Nexus.clm.TAB_TITLE,tabCode:type});Ext.Ajax.request({url:Nexus.clm.resourcePath,method:"GET",scope:self,suppressStatus:404,success:function(response){var clmSettings=Ext.decode(response.responseText);if(!Ext.isEmpty(clmSettings.url)){Nexus.clm.serverUrl=clmSettings.url;nexusPanel.clmMenu=nexusPanel.add({enabled:true,sectionId:"st-enterprise-staging",title:Nexus.clm.TITLE_DASHBOARD,href:Nexus.clm.serverUrl});nexusPanel.doLayout()}}})}});Nexus.staging.repository.RepositoriesMediator.addListener("staging.profile.loaded",function(items,properties,dataRoot){var clmAppPolicyURL;NX.log.debug("Enhancing UI with CLM details.");clmAppPolicyURL=new Ext.form.DisplayField({anchor:Sonatype.view.FIELD_OFFSET,allowBlank:true,hidden:!Ext.isDefined(Nexus.clm.serverUrl),appId:properties[key],showClmAppUrl:function(){var appId=clmAppPolicyURL.appId,url=Nexus.clm.serverUrl,text="CLM Dashboard";if(!Ext.isEmpty(appId)){while(url.endsWith("/")){url=url.substring(0,url.length-1)}url+="/assets/index.html#/management/application/"+appId+"/policies";text="CLM Application Management"}clmAppPolicyURL.setValue('<a href="'+url+'" target="_blank">'+text+"</a>")}});clmAppPolicyURL.showClmAppUrl();items.push([new Ext.form.ComboBox({fieldLabel:label,name:dataRoot+"."+key,value:properties[key],width:376,helpText:'Select a CLM Application to enable, or (none) to disable policy enforcement for this profile.<br/><a href="http://links.sonatype.com/products/clm/nexus/home"  target="_blank">Make Nexus Staging even more powerful with Sonatype CLM </a>',persistent:true,store:new Ext.data.JsonStore({id:"id",fields:[{name:"id"},{name:"name",sortType:Ext.data.SortTypes.asUCString}],sortInfo:{field:"name",direction:"ASC"},url:Nexus.clm.resourcePath+"/applications",autoLoad:true,listeners:{load:function(store){store.insert(0,NX.create("Ext.data.Record",{id:"",name:"(none)"}))}}}),displayField:"name",valueField:"id",editable:false,forceSelection:true,mode:"local",triggerAction:"all",emptyText:"Select...",selectOnFocus:true,allowBlank:true,listeners:{select:function(combo,record){clmAppPolicyURL.appId=record.get("id");clmAppPolicyURL.showClmAppUrl()}}}),clmAppPolicyURL])});Nexus.staging.repository.RepositoriesMediator.addListener("staging.profile.submitted",function(referenceData){NX.log.debug("Enhancing StagingProfile submit data with CLM details.");referenceData[key]=null});function renderClmValues(value,showDetailedReport){var values=value.split(",");NX.assert(values.length==6,"Should have 6 comma separated values stored for CLM violations.");return Nexus.clm.chickletTemplate.apply({criticalCount:values[2],severeCount:values[3],moderateCount:values[4],detailedReport:showDetailedReport?values[5]:null})}Nexus.staging.repository.RepositoriesMediator.addListener("staging.repositoriesGrid.configureColumns",function(columns){NX.log.debug("Enhancing Repository grid view with CLM details.");columns.push({id:"violations",width:250,header:"Violations",renderer:function(value,metaData,record){var properties=record.data.properties;if(properties!==undefined){var clmProperty;Ext.each(properties,function(property){if(property.name=="Violations"){clmProperty=property.value;return false}});if(clmProperty!==undefined){return renderClmValues(clmProperty,false)}}return"No CLM data recorded"}})});Nexus.staging.repository.RepositoriesMediator.addListener("staging.repositorySummary.configureProperties",function(properties,values){Ext.each(values.properties,function(property){if(property.name&&property.value&&property.name==="Violations"){NX.log.debug("Enhancing Repository summary view with CLM details.");for(var i=0;i<properties.length;i++){if(properties[i].name==="Activity"){break}}properties.splice(i+1,0,{name:"Violations",value:renderClmValues(property.value,true)});return false}})});Nexus.staging.repository.activity.EventDetail.registerBodyTemplateFactory("ruleFailed",Nexus.clm.stagingRule);Nexus.staging.repository.activity.EventDetail.registerBodyTemplateFactory("rulePassed",Nexus.clm.stagingRule)});
define("nexus-clm-plugin-boot",["Nexus/clm/SettingsView"],function(){Nexus.Log.debug("CLM plugin loaded")});
